#ifndef HSEARCH_H
#define HSEARCH_H

typedef struct entry {
    char           *key;
    char           *data;
}  ENTRY;

typedef enum {
    FIND,
    ENTER
}  ACTION;

typedef struct element {
    ENTRY           item;
    struct element *next;
}  ELEMENT;

extern ENTRY   *Hsearch(void *tp, ENTRY e, ACTION a);
extern void     Hdestroy(void *tp);
extern void    *Hcreate(int numelt);
extern void     Hprint(void *tp, FILE *fp, void (*f)());
extern void     Htext(FILE *fp, int indx, char *key, char *data);
extern void     Hdouble(FILE *fp, int indx, char *key, char *data);

#endif
